	@echo off
	rem *********************************************************************
	rem *  Filename : pack.bat
	rem *  An archive file creation program
	rem *  Copyright(C) 1996 Fumio Kawamata
	rem *
	rem * This batch program creats an archive for distribution.
	rem * The program compress files into an archive file in the hard
	rem * disk directory, and uncompress it for make sure.
	rem *
	rem * You need following programs when you execute this batch program.
	rem *   - Info-Zip's zip and unzip compression utility programs
	rem *   - rm, cp, and touch programs which run like UNIX programs
	rem * 
	rem * Remember that this batch program is designed for the author's
	rem * program environment.  Modify this program if you want use this. :-)
	rem *********************************************************************

:SetEnv
	rem *********************************************************************
	rem *  Sets environmet for program
	rem *********************************************************************
	set TimeStamp=04:01:00
	set DestName=c:\tmp\hj401.zip
	set DBName=database.zip
	set TestDir=c:\tmp\hj401
	set LogFile=c:\tmp\ziplog.txt


:Confirm
	rem *********************************************************************
	rem *  Confirms program parameters
	rem *********************************************************************
	cls
	echo This batch program will make an archive file.
	echo Zip File                 : %DestName%
	echo Time Stamp               : %TimeStamp%
	echo Test Directory           : %TestDir%
	echo Log File Name            : %LogFile%
	echo --------------------------------------------------------
	echo Hit any key to start."
	pause >NUL
	echo Log File>%LogFile%
	echo [5;1H[0J
	echo [6;1H
	echo ***********************************************
	echo **********     Now it is running     **********
	echo ***********************************************


	rem *********************************************************************
	rem *  Removes garbage files
	rem *********************************************************************
	echo [10;1H[0J
	echo [7mStep1: Removing garbage files.
	echo [0mStep2: Zipping files to %DestName%.
	echo [0mStep3: Unzipping  %DestName%  to  %TestDir%.
	cd ..
	echo Removing src\*.~*
	rm src\*.~*>nul
	echo Removing bin\*.dcu
	rm bin\*.dcu>nul
	echo Removing ..\hyperjuke_db\*.dcu
	rm ..\hyperjuke_db\*.dcu>nul
	echo Removing %DestName%
	if exist %DestName% rm %DestName%>nul
	echo Removing %DBName%
	if exist %DBName%   rm %DBName%>nul
	echo Removing %TestDir%
	rm -R -f %TestDir%>nul
	echo Finished

	rem *********************************************************************
	rem *  Compress files
	rem *********************************************************************
	echo [10;1H[0J
	echo [0mStep1: Removing garbage files.
	echo [7mStep2: Zipping files to %DestName%.
	echo [0mStep3: Unzipping  %DestName%  to  %TestDir%.

	echo Touching...
	touch -t%TimeStamp% bin\hyperjuke.exe>nul
	touch -r -ebin\hyperjuke.exe  *.*>nul
	touch -r -ebin\hyperjuke.exe  ..\HYPERJUKE_DB\*.*>nul

	echo Zipping HyperJuke_DB\* into %DBName% ...
	cd ..\HyperJuke_DB
	cd
	zip -r ..\HyperJuke\%DBName% *>>%LogFile%

	echo Zipping HyperJuke\* into %DestName% ... 
	cd ..\HyperJuke
	cd
	zip -r %DestName%  *>>%LogFile%

	echo Deleting %DBName%
	del %DBName%

	echo Zipping bde32-j ...
	cd ..
	zip -r %DestName% bde32-j\*>>%LogFile%


	rem *********************************************************************
	rem *  Uncompress the file into the test directory
	rem *********************************************************************
	echo [10;1H[0J
	echo [0mStep1: Removing garbage files.
	echo [0mStep2: Zipping files to %DestName%.
	echo [7mStep3: Unzipping  %DestName%  to  %TestDir%.[0m
	mkdir %TestDir%>nul
	unzip %DestName% -d %TestDir%>>%LogFile%


	rem *********************************************************************
	rem *  Displays the ending message
	rem *********************************************************************
	echo [0m
	echo [6;1H[0J
	echo All done.
	c:
	cd %TestDir%

:Exit

