///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Empty_P;

interface

uses
  MyProc,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, StdCtrls, Buttons;

type
  TformEmptyPersonalTables = class(TForm)
    editVerify: TEdit;
    bitbtnDoIt: TBitBtn;
    bitbtnCancel: TBitBtn;
    tableTarget: TTable;
    labelMessage: TLabel;
    labelVerifyString: TLabel;
    procedure bitbtnDoItClick(Sender: TObject);
    procedure bitbtnCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
  procedure MyEmptyTable(TargetName: String);
  public
  end;

var
  formEmptyPersonalTables: TformEmptyPersonalTables;

implementation

uses Main;

{$R *.DFM}

const
  VerifyString = 'I know what I am doing.';


//*************************************************************************
//* Emptys table
//*************************************************************************
procedure TformEmptyPersonalTables.MyEmptyTable(TargetName: String);
begin
  With tableTarget do
    begin
      Active:=False;
      Databasename:='HyperJuke_P';
      TableName:= TargetName;
      EmptyTable;
    end;
end;


//*************************************************************************
//* Emptys tables personaly used
//*************************************************************************
procedure TformEmptyPersonalTables.bitbtnDoItClick(Sender: TObject);
var
  I : Integer;
begin
  if editVerify.Text=VerifyString then
    begin
      for I:=0 to formMain.MDIChildCount-1 do
        begin
          formMain.MDIChildren[I].Close;
        end;
      MyEmptyTable('KEYWORD.DB');
      MyEmptyTable('TASTE.DB');
      MyProc.Inform('Emptied personal tables.');
      formEmptyPersonalTables.Release;
    end
    else
    begin
      MyProc.Inform('Verify text was mismatched.');
    end;
end;


//*************************************************************************
//* Releases the form
//*************************************************************************
procedure TformEmptyPersonalTables.bitbtnCancelClick(Sender: TObject);
begin
  Release;
end;


//*************************************************************************
//* Release the form when form coloses
//*************************************************************************
procedure TformEmptyPersonalTables.FormClose(Sender: TObject;
 var Action: TCloseAction);
begin
  Action:=caFree;
end;


//*************************************************************************
//* Sets caption for verifying string
//*************************************************************************
procedure TformEmptyPersonalTables.FormCreate(Sender: TObject);
begin
  labelVerifyString.Caption:=VerifyString;
end;

end.
