///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Musiclst;

interface

uses
  MyFunc,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, StdCtrls, DBCtrls, ExtCtrls,
  Buttons;

type
  TformMusicTitles = class(TForm)
    panelButtom: TPanel;
    datasourceMusic: TDataSource;
    dbgridMusic: TDBGrid;
    bitbtnClose: TBitBtn;
    bitbtnDetails: TBitBtn;
    queryMusic: TQuery;
    queryMusicUNIT_ID: TStringField;
    queryMusicSLOT_ID: TStringField;
    queryMusicDISC_ID: TStringField;
    queryMusicDISC_ID_1: TStringField;
    queryMusicTRACK1: TSmallintField;
    queryMusicTRACK2: TSmallintField;
    queryMusicTITLE: TStringField;
    queryMusicPLAYER: TStringField;
    queryMusicVERSIFIER: TStringField;
    queryMusicCOMPOSER: TStringField;
    queryMusicARRANGER: TStringField;
    queryMusicVOLUME: TSmallintField;
    queryMusicDISC_ID_2: TStringField;
    queryMusicTRACK1_1: TSmallintField;
    queryMusicTRACK2_1: TSmallintField;
    queryMusicKEYWORD: TStringField;
    queryMusicTASTE: TSmallintField;
    queryMusicCOUNTER: TIntegerField;
    queryMusicTMP_TIME: TStringField;
    queryMusicFRAMES: TIntegerField;
    queryMusicMEMO: TMemoField;
    bitbtnRefresh: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure queryMusicCalcFields(DataSet: TDataset);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure bitbtnDetailsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure bitbtnRefreshClick(Sender: TObject);
  private
  public
  end;

var
  formMusicTitles: TformMusicTitles;

implementation

uses Music;

{$R *.DFM}


//*************************************************************************
//* Minimizes the form
//*************************************************************************
procedure TformMusicTitles.FormCreate(Sender: TObject);
begin
  WindowState:=wsMinimized;
end;


//*************************************************************************
//* Displays TIME converted from FRAMES
//*************************************************************************
procedure TformMusicTitles.queryMusicCalcFields(DataSet: TDataset);
begin
  with queryMusic do begin
    FieldByName('TMP_TIME').AsString
      := MyFunc.FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//*************************************************************************
//* Closes the form
//*************************************************************************
procedure TformMusicTitles.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//*************************************************************************
//* Closes the form
//*************************************************************************
procedure TformMusicTitles.bitbtnDetailsClick(Sender: TObject);
var
  SelectedDiscID : string;
  SelectedTrack1 : Integer;
  SelectedTrack2 : Integer;
begin
  Application.CreateForm(TformDetailsOfMusic, formDetailsOfMusic);
  SelectedDiscID:=queryMusic.FieldByName('DISC_ID').AsString;
  SelectedTrack1:=queryMusic.FieldByName('TRACK1').AsInteger;
  SelectedTrack2:=queryMusic.FieldByName('TRACK2').AsInteger;
  with formDetailsOfMusic do begin
    queryDisc.Active:=False;
    queryDisc.Prepare;
    queryDisc.Close;
    queryDisc.Params[0].AsString:=SelectedDiscID;
    queryDisc.Open;
    queryDisc.Active:=True;

    queryMusic.Active:=False;
    queryMusic.Prepare;
    queryMusic.Close;
    queryMusic.Params[0].AsString:=SelectedDiscID;
    queryMusic.Params[1].AsInteger:=SelectedTrack1;
    queryMusic.Params[2].AsInteger:=SelectedTrack2;
    queryMusic.Open;
    queryMusic.Active:=True;
    WindowState:=wsNormal;
    Show;
  end;
end;


//*************************************************************************
//* Refreshs the form
//*************************************************************************
procedure TformMusicTitles.FormActivate(Sender: TObject);
begin
  queryMusic.Refresh;
end;


//*************************************************************************
//* Requerys the queryMusic query
//*************************************************************************
procedure TformMusicTitles.bitbtnRefreshClick(Sender: TObject);
begin
  Screen.Cursor:=crSQLWait;
  try
    queryMusic.Active:=False;
    queryMusic.Active:=True;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

end.
