///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************

// Notice:
// This unit calls SetProgramInformations procedure.

unit about;

interface

uses
  SetInfo, GNUGPL,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TformAbout = class(TForm)
    bitbtnAuthor        : TBitBtn;
    bitbtnClose         : TBitBtn;
    bitbtnGNUGPL        : TBitBtn;
    imageProgIcon       : TImage;
    labelCopyright      : TLabel;
    labelProgNameUpper  : TLabel;
    labelDistribute     : TLabel;
    labelProgComment    : TLabel;
    labelProgNameLower  : TLabel;
    labelVersion        : TLabel;
    procedure bitbtnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bitbtnGNUGPLClick(Sender: TObject);
    procedure bitbtnAuthorClick(Sender: TObject);
  private
  public
  end;

var
  formAbout: TformAbout;

implementation

uses author;

{$R *.DFM}


//*************************************************************************
//* Hides myself
//*************************************************************************
procedure TformAbout.bitbtnCloseClick(Sender: TObject);
begin
  formAbout.Close;
end;


//*************************************************************************
//* Sets captions and the image
//*************************************************************************
procedure TformAbout.FormCreate(Sender: TObject);
begin
  SetProgramInformations(Sender);
  formAbout.hide;
end;


//*************************************************************************
//* Opens GNU GPL document form
//*************************************************************************
procedure TformAbout.bitbtnGNUGPLClick(Sender: TObject);
begin
  formGNUGPL.ShowModal;
end;

//*************************************************************************
//* Opens about the author form
//*************************************************************************
procedure TformAbout.bitbtnAuthorClick(Sender: TObject);
begin
  formAuthor.ShowModal;
end;

end.
