///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Disc;

interface

uses
  MyProc, MyFunc, Player,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, Grids, DBGrids, DB, Menus, DBCtrls, ExtCtrls,
  StdCtrls, Mask,
  Music, MPlayer, Buttons;

type
  TformDetailsOfDisc = class(TForm)
    panelBottom: TPanel;
    datasourceDisc: TDataSource;
    datasourceMusic: TDataSource;
    dbgridMusic: TDBGrid;
    panelTop: TPanel;
    dbtextDiscID: TDBText;
    labelDiscID: TLabel;
    labelTitle: TLabel;
    labelTitle2: TLabel;
    dbeditTitle: TDBEdit;
    dbeditTitle2: TDBEdit;
    dbeditCatetegory: TDBEdit;
    dbeditIndex: TDBEdit;
    labelCategory: TLabel;
    labelIndex: TLabel;
    dbeditProduction: TDBEdit;
    dbtextTracks: TDBText;
    dbtextTime: TDBText;
    labelProduction: TLabel;
    labelTracks: TLabel;
    labelTime: TLabel;
    queryDisc: TQuery;
    queryMusic: TQuery;
    queryMusicDISC_ID: TStringField;
    queryMusicTITLE: TStringField;
    queryMusicPLAYER: TStringField;
    queryMusicVERSIFIER: TStringField;
    queryMusicCOMPOSER: TStringField;
    queryMusicARRANGER: TStringField;
    dbnavigatorDisc: TDBNavigator;
    queryMusicKeywords: TStringField;
    tableTaste: TTable;
    mediaplayerCD: TMediaPlayer;
    queryMusicTRACK1: TSmallintField;
    queryMusicTRACK2: TSmallintField;
    queryMusicFRAMES: TIntegerField;
    queryMusicVOLUME: TSmallintField;
    queryMusicTASTE: TSmallintField;
    queryMusicCOUNTER: TIntegerField;
    tableProg: TTable;
    queryDiscDISC_ID: TStringField;
    queryDiscTITLE: TStringField;
    queryDiscTITLE2: TStringField;
    queryDiscPRODUCTION: TStringField;
    queryDiscCATEGORY: TStringField;
    queryDiscINDEX: TStringField;
    queryDiscTRACKS: TSmallintField;
    queryDiscFRAMES: TIntegerField;
    queryDiscTMP_TIME: TStringField;
    queryMusicTMP_TIME: TStringField;
    bitbtnClose: TBitBtn;
    bitbtnDetail: TBitBtn;
    bitbtnReadDisc: TBitBtn;
    bitbtnPlay: TBitBtn;
    bitbtnNavAppend: TBitBtn;
    dbnavigatorMusic: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure queryMusicCalcFields(DataSet: TDataset);
    procedure queryMusicNewRecord(DataSet: TDataset);
    procedure queryDiscCalcFields(DataSet: TDataset);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure bitbtnDetailClick(Sender: TObject);
    procedure bitbtnReadDiscClick(Sender: TObject);
    procedure bitbtnPlayClick(Sender: TObject);
    procedure bitbtnNavAppendClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
  public
  end;

var
  formDetailsOfDisc: TformDetailsOfDisc;

implementation

{$R *.DFM}
const
  CRLF = chr($0D)+chr($0A);

//******************************************************************************
//* Opens ditails of music form
//******************************************************************************
procedure TformDetailsOfDisc.bitbtnDetailClick(Sender: TObject);
var
     SelectedDiscID : string;
     SelectedTrack1 : Integer;
     SelectedTrack2 : Integer;
begin
  Application.CreateForm(TformDetailsOfMusic, formDetailsOfMusic);
  SelectedDiscID:=queryMusic.FieldByName('DISC_ID').AsString;
  SelectedTrack1:=queryMusic.FieldByName('TRACK1').AsInteger;
  SelectedTrack2:=queryMusic.FieldByName('TRACK2').AsInteger;
  with formDetailsOfMusic do begin
    queryDisc.Active:=False;
    queryDisc.Prepare;
    queryDisc.Close;
    queryDisc.Params[0].AsString:=SelectedDiscID;
    queryDisc.Open;
    queryDisc.Active:=True;

    queryMusic.Active:=False;
    queryMusic.Prepare;
    queryMusic.Close;
    queryMusic.Params[0].AsString:=SelectedDiscID;
    queryMusic.Params[1].AsInteger:=SelectedTrack1;
    queryMusic.Params[2].AsInteger:=SelectedTrack2;
    queryMusic.Open;
    queryMusic.Active:=True;
    WindowState:=wsNormal;
    Show;
  end;
end;


//******************************************************************************
//* Executes when form is created
//******************************************************************************
procedure TformDetailsOfDisc.FormCreate(Sender: TObject);
begin
  Width:=750;
  WindowState:=wsMinimized;
  tableProg.Active:=False;
  tableProg.Databasename:=ExtractFilePath(ParamStr(0))+'WORK';
  tableProg.Active:=True;
end;


//******************************************************************************
//* Calculates fields
//******************************************************************************
procedure TformDetailsOfDisc.queryMusicCalcFields(DataSet: TDataset);
begin
  If tableTaste.FindKey([DataSet.FieldByName('DISC_ID').AsString,
                         DataSet.FieldByName('TRACK1').AsInteger,
                         DataSet.FieldByName('TRACK2').AsInteger]) then begin
    queryMusicTaste.AsInteger:=tableTaste.FieldByName('TASTE').AsInteger;
    queryMusicCounter.AsInteger:=tableTaste.FieldByName('COUNTER').AsInteger;
    queryMusicKeywords.AsString:=tableTaste.FieldByName('KEYWORD').AsString;
  end;
  with queryMusic do begin
    FieldByName('TMP_TIME').AsString:=FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//******************************************************************************
//* Reads disc
//******************************************************************************
procedure TformDetailsOfDisc.bitbtnReadDiscClick(Sender: TObject);
var
  Frames         : Longint;
  I              : word;
  MessageStr     : String;
  Track1         : Integer;
  Track2         : Integer;
  Tracks         : Integer;
begin
  MessageStr:='Are you sure to read number of tracks and time of the CD?';
  if MyFunc.AskYesNo(MessageStr)=mrNo then Exit;
  mediaplayerCD.TimeFormat:=tfMSF;
  try
    mediaplayerCD.Open;
  except
    MessageStr:='Could not open the CD-Audio player.  '+ CRLF +
                'It may be occupied by another process.';
    MyProc.Warning(MessageStr);
    mediaplayerCD.Close;
    exit;
  end;
  Tracks:=mediaplayerCD.Tracks;
  Frames:=MyFunc.MSFtoFrame(mediaplayerCD.Length);
  with mediaplayerCD do begin
    if Error<>0 then begin
      MessageDlg('Error='+IntToStr(Error)+CRLF+
      'Error Message='+ErrorMessage, mtInformation, [mbOK], 0);
    end;
  end;
  with queryDisc do begin
    Edit;
    FieldByName('TRACKS').AsInteger:=Tracks;
    FieldByName('FRAMES').AsInteger:=Frames;
    Post;
  end;
  dbtextTracks.Refresh;
  dbtextTime.Refresh;

  mediaplayerCD.TimeFormat:=tfMSF;
  with queryMusic do begin
    if Recordcount>0 then begin
      First;
      while not(Eof) do begin
        Track1:=FieldByName('TRACK1').AsInteger;
        Track2:=FieldByName('TRACK2').AsInteger;
        Frames:=0;
        for I:=Track1 to Track2 do begin
          Frames:=Frames+MyFunc.MSFtoFrame(mediaplayerCD.TrackLength[I]);
        end;
        Edit;
        FieldByName('FRAMES').AsInteger:=Frames;
        Post;
        Next;
      end;
    end;
  end;
  mediaplayerCD.Close;
end;


//******************************************************************************
//* Executes when new record event of the MUSIC table occurs
//******************************************************************************
procedure TformDetailsOfDisc.queryMusicNewRecord(DataSet: TDataset);
begin
  queryMusic.FieldByName('DISC_ID').AsString:=
    queryDisc.FieldByName('DISC_ID').AsString;
end;


//******************************************************************************
//* Opens player form
//******************************************************************************
procedure TformDetailsOfDisc.bitbtnPlayClick(Sender: TObject);
var
  MessageStr  : String;
  No   : Integer;
begin
  {queryMusic.Last;}
  if queryMusic.RecordCount=0 then begin
    Warning('There is no record.');
    Exit;
  end
  else begin
    MessageStr:='The program will play this CD.'+CRLF+
                'Are you sure?';
    if MyFunc.AskYesCancel(MessageStr)=mrCancel then Exit;
    No:=1;
    queryMusic.First;
    tableProg.Active:=False;
    tableProg.EmptyTable;
    tableProg.Active:=True;
    repeat
      tableProg.Append;
      tableProg.FieldByName('NO').AsInteger:=No;
      tableProg.FieldByName('UNIT_ID').AsString:='CD-Audio';
      tableProg.FieldByName('SLOT_ID').AsString:='0';
      tableProg.FieldByName('DISC_ID').AsString
        :=queryDisc.FieldByName('DISC_ID').AsString;
      tableProg.FieldByName('TRACK1').AsInteger
        :=queryMusic.FieldByName('TRACK1').AsInteger;
      tableProg.FieldByName('TRACK2').AsInteger
        :=queryMusic.FieldByName('TRACK2').AsInteger;
      tableProg.Post;
      queryMusic.Next;
      inc(No);
    until queryMusic.Eof;
    formPlayer.Show;
    formPlayer.tableProg.Refresh;
  end;
end;


//******************************************************************************
//* Calculates fields
//******************************************************************************
procedure TformDetailsOfDisc.queryDiscCalcFields(DataSet: TDataset);
begin
  with queryDisc do begin
    FieldByName('TMP_TIME').AsString
      :=FrameToTime(FieldByName('FRAMES').AsInteger);
  end;
end;


//******************************************************************************
//* Closes myself
//******************************************************************************
procedure TformDetailsOfDisc.bitbtnCloseClick(Sender: TObject);
begin
  if queryDisc.Modified then queryDisc.Post;
  if queryMusic.Modified then queryMusic.Post;
  Release;
end;


//******************************************************************************
//* Appends a new record to music table
//******************************************************************************
procedure TformDetailsOfDisc.bitbtnNavAppendClick(Sender: TObject);
var
  LastTrack  : Integer;
begin
  with queryMusic do begin
    if RecordCount=0 then begin
       Append;
       FieldByName('TRACK1').AsInteger:=1;
       FieldByName('TRACK2').AsInteger:=2;
    end
    else begin
       Last;
       LastTrack:=FieldByName('TRACK2').AsInteger;
       Append;
       FieldByName('TRACK1').AsInteger:=LastTrack+1;
       FieldByName('TRACK2').AsInteger:=LastTrack+1;
    end;
  end;
end;


//******************************************************************************
//* Executes before closing form
//******************************************************************************
procedure TformDetailsOfDisc.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if queryDisc.Modified then queryDisc.Post;
  if queryMusic.Modified then queryMusic.Post;
  Action:=caFree;
end;


//******************************************************************************
//* Executes when deactivating form
//* Checks that the item in the current record was modified or not.
//* If it was modified, executes the Post method.
//******************************************************************************
procedure TformDetailsOfDisc.FormDeactivate(Sender: TObject);
begin
  if queryDisc.Modified then queryDisc.Post;
  if queryMusic.Modified then queryMusic.Post;
end;

procedure TformDetailsOfDisc.FormActivate(Sender: TObject);
begin
  queryDisc.Refresh;
  queryMusic.Refresh;
end;

end.
