///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
program HyperJuke;

uses
  Forms,
  Controls,
  MyFunc in 'MYFUNC.PAS',
  MyProc in 'MYPROC.PAS',
  About in 'ABOUT.PAS' {formAbout},
  GNUGPL in 'GNUGPL.PAS' {formGNUGPL},
  Author in 'AUTHOR.PAS' {formAuthor},
  Splash in 'SPLASH.PAS' {formSplash},
  SetInfo in 'SETINFO.PAS',
  Main in 'MAIN.PAS' {formMain},
  Location in 'LOCATION.PAS' {formLocationList},
  Unitlist in 'UNITLIST.PAS' {formUnitTitles},
  Disclist in 'DISCLIST.PAS' {formDiscTitles},
  Disc in 'DISC.PAS' {formDetailsOfDisc},
  Discmus in 'DISCMUS.PAS' {formDiscAndMusicTitles},
  MusicLst in 'MUSICLST.PAS' {formMusicTitles},
  Music in 'MUSIC.PAS' {formDetailsOfMusic},
  Titlebak in 'TITLEBAK.PAS' {formTitleBack},
  Keyword in 'KEYWORD.PAS' {formKeyword},
  Login in 'LOGIN.PAS' {formLogin},
  Autoload in 'AUTOLOAD.PAS' {formQuickRecall},
  Player in 'PLAYER.PAS' {formPlayer},
  Empty_C in 'Empty_C.pas' {formEmptyCommonTables},
  Empty_P in 'Empty_P.pas' {formEmptyPersonalTables},
  category in 'category.pas' {formCategory},
  arrange in 'arrange.pas' {formArrangePersonalTable};
{$R *.RES}

//*************************************************************************
//* Displays progressing
//*************************************************************************
procedure Progress(var I:word; StatusMessage:String);
begin
  // formSplash.labelStatus.Caption:=StatusMessage;
  formSplash.progressbarLoading.Position:=I;
  formSplash.Update;
  inc(I);
  Screen.Cursor:=crAppStart;
end;



var
  I : word;
begin
  Application.Title := 'Hyper Juke';
  Application.ShowHint:=False;
  formSplash.progressbarLoading.Max:=15;
  I:=1;
  Screen.Cursor:=crAppStart;
  Application.CreateForm(TformMain, formMain);
  Progress(I,'Main');

  // MDI form for titleback
  Application.CreateForm(TformTitleBack, formTitleBack); Progress(I, 'TitleBack');

  // MDI forms (Must be in alphabetical order for the window list)
  Application.CreateForm(TformCategory, formCategory); Progress(I,'Category');
  Application.CreateForm(TformDiscAndMusicTitles, formDiscAndMusicTitles); Progress(I,'Disc&Music Titles');
  Application.CreateForm(TformDiscTitles, formDiscTitles); Progress(I,'Disc Titles');
  Application.CreateForm(TformKeyword, formKeyword); Progress(I,'Keyword');
  Application.CreateForm(TformLocationList, formLocationList); Progress(I,'Location List');
  Application.CreateForm(TformMusicTitles, formMusicTitles); Progress(I,'Music Titles');
  Application.CreateForm(TformUnitTitles, formUnitTitles); Progress(I,'UnitTitle');

  // Normal forms
  Application.CreateForm(TformAbout, formAbout); Progress(I,'About');
  Application.CreateForm(TformGNUGPL, formGNUGPL); Progress(I,'GNU GPL');
  Application.CreateForm(TformAuthor, formAuthor); Progress(I,'Author');
  Application.CreateForm(TformLogin, formLogin); Progress(I,'Login');
  Application.CreateForm(TformPlayer, formPlayer); Progress(I,'Player');
  Application.CreateForm(TformQuickRecall, formQuickRecall); Progress(I,'Quick Recall');

  Screen.Cursor:=crDefault;
  Application.Run;
end.
