///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Keyword;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, ExtCtrls, Grids, DBGrids, DBCtrls,
  StdCtrls, Buttons;

type
  TformKeyword = class(TForm)
    tableKeyword: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    panelBottom: TPanel;
    tableKeywordKEYWORD: TStringField;
    dbnavigator1: TDBNavigator;
    bitbtnAppend: TBitBtn;
    bitbtnClose: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure bitbtnAppendClick(Sender: TObject);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
  private
  public
  end;

var
  formKeyword: TformKeyword;

implementation

{$R *.DFM}


//*************************************************************************
//* Sets the form width and minimizes the form
//*************************************************************************
procedure TformKeyword.FormCreate(Sender: TObject);
begin
  Width:=163;
  WindowState:=wsMinimized;
end;


//*************************************************************************
//* Append new record to the "Keyword" table
//*************************************************************************
procedure TformKeyword.bitbtnAppendClick(Sender: TObject);
begin
  tableKeyword.Append;
end;


//*************************************************************************
//* Closes form
//*************************************************************************
procedure TformKeyword.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//*************************************************************************
//* Posts the "Keyword" table if it is modified
//*************************************************************************
procedure TformKeyword.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if tableKeyword.Modified then tableKeyword.Post;
end;


//*************************************************************************
//* Posts the "Keyword" table if it is modified
//*************************************************************************
procedure TformKeyword.FormDeactivate(Sender: TObject);
begin
  if tableKeyword.Modified then tableKeyword.Post;
end;

end.
