///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Location;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBCtrls, ExtCtrls, Grids, DBGrids, DB, DBTables, Menus,
  Disc, StdCtrls, Buttons;

type
  TformLocationList = class(TForm)
    panelBottom: TPanel;
    dbnav1: TDBNavigator;
    datasource1: TDataSource;
    dbgridLocation: TDBGrid;
    tableLocation: TTable;
    tableDisc: TTable;
    tableLocationUNIT_ID: TStringField;
    tableLocationSLOT_ID: TStringField;
    tableLocationDISC_ID: TStringField;
    tableLocationWORK_TITLE: TStringField;
    tableLocationWORK_TITLE2: TStringField;
    bitbtnDetailsOfDisc: TBitBtn;
    bitbtnAppend: TBitBtn;
    bitbtnClose: TBitBtn;
    procedure tableLocationCalcFields(DataSet: TDataset);
    procedure dbgridLocationColExit(Sender: TObject);
    procedure Hint(Sender: TObject);
    procedure menuCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bitbtnDetailsOfDiscClick(Sender: TObject);
    procedure bitbtnCloseClick(Sender: TObject);
    procedure bitbtnAppendClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declaration }
  public
    { Public declaration }
  end;

var
  formLocationList: TformLocationList;

implementation

{$R *.DFM}

//*************************************************************************
//* Displays TITLE and TITLE2
//*************************************************************************
procedure TformLocationList.tableLocationCalcFields(DataSet: TDataset);
begin
     if tableDisc.FindKey([DataSet.FieldByName('DISC_ID').AsString]) then
       begin
         tableLocationWORK_TITLE.AsString
           :=tableDisc.FieldByName('TITLE').AsString;
         tableLocationWORK_TITLE2.AsString
           :=tableDisc.FieldByName('TITLE2').AsString;
     end;
end;


//*************************************************************************
//* Invalidates the Location dbgrid
//*************************************************************************
procedure TformLocationList.dbgridLocationColExit(Sender: TObject);
begin
     dbgridLocation.Invalidate;
end;


//*************************************************************************
//* Displays hint
//*************************************************************************
procedure TformLocationList.Hint(Sender: TObject);
const
     Msg='This form displays the relation among Unit, Slot, and Disc.';
begin
     MessageDlg(Msg, mtInformation, [mbOK],0);
end;


//*************************************************************************
//* Closes form
//*************************************************************************
procedure TformLocationList.menuCloseClick(Sender: TObject);
begin
     Close;
end;


//*************************************************************************
//* Minimizes the form
//*************************************************************************
procedure TformLocationList.FormCreate(Sender: TObject);
begin
  WindowState:=wsMinimized;
  tableLocation.Refresh; // Needed for OnCalc event handler
end;


//*************************************************************************
//* Opens the "Details of Disc" form
//*************************************************************************
procedure TformLocationList.bitbtnDetailsOfDiscClick(Sender: TObject);
var
     SelectedDiscID : string;
begin
  Application.CreateForm(TformDetailsOfDisc, formDetailsOfDisc);
  SelectedDiscID:=tableLocation.FieldByName('DISC_ID').AsString;
  with formDetailsOfDisc do begin
    queryDisc.Active:=False;
    queryDisc.Prepare;
    queryDisc.Close;
    queryDisc.Params[0].AsString:=SelectedDiscID;
    queryDisc.Open;
    queryDisc.Active:=True;
    queryMusic.Active:=False;
    queryMusic.Prepare;
    queryMusic.Close;
    queryMusic.Params[0].AsString:=SelectedDiscID;
    queryMusic.Open;
    queryMusic.Active:=True;
    Show;
    WindowState:=wsNormal;
  end;
end;


//*************************************************************************
//* Closes form
//*************************************************************************
procedure TformLocationList.bitbtnCloseClick(Sender: TObject);
begin
  Close;
end;


//*************************************************************************
//* Appends new record to "Location List" table
//*************************************************************************
procedure TformLocationList.bitbtnAppendClick(Sender: TObject);
begin
  tableLocation.Append;
end;


//*************************************************************************
//* Refreshs "Disc List" table and "Location List" table
//*************************************************************************
procedure TformLocationList.FormActivate(Sender: TObject);
begin
  tableDisc.Refresh;
  tableLocation.Refresh;
end;


//*************************************************************************
//* Posts "Locatin List" table if it is modified
//*************************************************************************
procedure TformLocationList.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if tableLocation.Modified then tableLocation.Post;
end;


//*************************************************************************
//* Posts "Locatin List" table if it is modified
//*************************************************************************
procedure TformLocationList.FormDeactivate(Sender: TObject);
begin
  if tableLocation.Modified then tableLocation.Post;
end;

end.
