///////////////////////////////////////////////////////////////////////////
//            Hyper Juke, Audio-CD database with media player.           //
//                Copyright (C) 1990,1996 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit Main;

interface

uses
  AutoLoad, UnitList,Location, About, DiscMus, Disc, DiscList, Keyword,
  Player,
  ShellAPI, SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, Menus, StdCtrls,ExtCtrls, MPlayer, ComCtrls,
  Buttons;


type
  TformMain = class(TForm)
    menuMain: TMainMenu;
    menuFile: TMenuItem;
    menuQuit: TMenuItem;
    menuHelp: TMenuItem;
    menuHint: TMenuItem;
    menuAbout: TMenuItem;
    menuQuickRecall: TMenuItem;
    menuPlayer: TMenuItem;
    menuWindow: TMenuItem;
    statusbar1: TStatusBar;
    menuTile: TMenuItem;
    menuCascade: TMenuItem;
    menuArrangeIcons: TMenuItem;
    menuAdmin: TMenuItem;
    menuEmptyCommonTables: TMenuItem;
    menuEmptyPersonalTables: TMenuItem;
    menuArrangeRecords: TMenuItem;
    menuHelpContents: TMenuItem;
    menuHelpContentsJ: TMenuItem;
    procedure menuQuitClick(Sender: TObject);
    procedure menuContentsInEnglishClick(Sender: TObject);
    procedure menueContentsInJapaneseClick(Sender: TObject);
    procedure menuHintClick(Sender: TObject);
    procedure onFormCreate(Sender: TObject);
    procedure menuAboutClick(Sender: TObject);
    procedure menuQuickRecallClick(Sender: TObject);
    procedure menuPlayerClick(Sender: TObject);
    procedure menuTileClick(Sender: TObject);
    procedure menuCascadeClick(Sender: TObject);
    procedure menuArrangeIconsClick(Sender: TObject);
    procedure menuEmptyCommonTablesClick(Sender: TObject);
    procedure menuEmptyPersonalTablesClick(Sender: TObject);
    procedure menuArrangeRecordsClick(Sender: TObject);
  private
  public
  end;

var
  formMain: TformMain;

implementation

uses GNUGPL, Author, Empty_C, Empty_P, arrange;

{$R *.DFM}


//*************************************************************************
//* Displays the result when help file was opened
//*************************************************************************
procedure DisplayResult(Code: word; FileName:string);
var
     CodeStr        : string;
begin
     if Code<32 then begin
          str(Code, CodeStr);
          MessageDlg('Could not open "'+FileName+'".'+chr($0D)+
               'Return Code was '+CodeStr+' .', mtWarning, [mbOK],0);
     end;
end;


//*************************************************************************
//* Closes the form
//*************************************************************************
procedure TformMain.menuQuitClick(Sender: TObject);
begin
     formMain.Close;
end;


//*************************************************************************
//* Opens help contents in English
//*************************************************************************
procedure TformMain.menuContentsInEnglishClick(Sender: TObject);
const
     FileName = '..\manual\index.html';
var
     Ans       : word;
begin
     Ans:=ShellExecute(Handle, 'open', FileName, nil, nil, SW_SHOWNORMAL);
     DisplayResult(Ans, FileName);
end;


//*************************************************************************
//* Opens help contents in Japanese
//*************************************************************************
procedure TformMain.menueContentsInJapaneseClick(Sender: TObject);
const
     FileName = '..\manual\index-j.html';
var
     Ans       : word;
begin
     Ans:=ShellExecute(Handle, 'open', FileName, nil, nil, SW_SHOWNORMAL);
     DisplayResult(Ans, FileName);
end;


//*************************************************************************
//* Alternates status of the showhint switch
//*************************************************************************
procedure TformMain.menuHintClick(Sender: TObject);
begin
  case menuHint.Checked of
    True: begin
      menuHint.Checked:=False;
      menuHint.Caption:='Hint (Now Disabled)(&I)';
      Application.ShowHint:=False;
    end;
    False: begin
      menuHint.Checked:=True;
      menuHint.Caption:='Hint (Now Enabled)(&I)';
      Application.ShowHint:=True;
    end;
  end;
end;


//*************************************************************************
//* Executes when the form creates
//*************************************************************************
procedure TformMain.onFormCreate(Sender: TObject);
begin
  Width:=800;
  Height:=600;
end;


//*************************************************************************
//* Opens the About form
//*************************************************************************
procedure TformMain.menuAboutClick(Sender: TObject);
begin
  formAbout.ShowModal;
end;


//*************************************************************************
//* Opens the Quick Recall form
//*************************************************************************
procedure TformMain.menuQuickRecallClick(Sender: TObject);
begin
  formQuickRecall.Show;
end;


//*************************************************************************
//* Opens the Player form
//*************************************************************************
procedure TformMain.menuPlayerClick(Sender: TObject);
begin
  formPlayer.Show;
end;


//*************************************************************************
//* Tiles MDI child forms
//*************************************************************************
procedure TformMain.menuTileClick(Sender: TObject);
begin
  Tile;
end;


//*************************************************************************
//* Cascades MDI child forms
//*************************************************************************
procedure TformMain.menuCascadeClick(Sender: TObject);
begin
  Cascade;
end;


//*************************************************************************
//* Arranges MDI children icons
//*************************************************************************
procedure TformMain.menuArrangeIconsClick(Sender: TObject);
begin
  ArrangeIcons;
end;


//*************************************************************************
//* Emptys tables commonly used by the all users
//*************************************************************************
procedure TformMain.menuEmptyCommonTablesClick(Sender: TObject);
begin
  Application.CreateForm(TformEmptyCommonTables, formEmptyCommonTables);
  formEmptyCommonTables.ShowModal;
end;


//*************************************************************************
//* Emptys tables personaly used
//*************************************************************************
procedure TformMain.menuEmptyPersonalTablesClick(Sender: TObject);
begin
  Application.CreateForm(TformEmptyPersonalTables, formEmptyPersonalTables);
  formEmptyPersonalTables.ShowModal;
end;


//*************************************************************************
//* Opens the Arrange Records form
//*************************************************************************
procedure TformMain.menuArrangeRecordsClick(Sender: TObject);
begin
  Application.CreateForm(TformArrangePersonalTable, formArrangePersonalTable);
  //formArrangePersonalTable.WindowState:=wsNormal;
  //formArrangePersonalTable.Show;
end;


end.
