///////////////////////////////////////////////////////////////////////////
//                       Alias manager for Hyper Juke                    //
//                Copyright (C) 1990,1997 Fumio Kawamata                 //
//                                                                       //
//  This program is free software; you can redistribute it and/or modify //
//  it under the terms of the GNU General Public License as published by //
//  the Free Software Foundation; version 2 of the License.              //                                                    //
//                                                                       //
//  This program is distributed in the hope that it will be useful, but  //
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT- //
//  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General    //
//  Public License in the directory "GNUGPL" for more details.           //
///////////////////////////////////////////////////////////////////////////
//*************************************************************************
//*
//*************************************************************************
unit setaliases;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Buttons, DB, DBTables;

type
  TformMain = class(TForm)
    bitbtnOK: TBitBtn;
    bitbtnCancel: TBitBtn;
    labelExplanation: TLabel;
    labelCommonDatabase: TLabel;
    labelPersonalDatabase: TLabel;
    editCommonDatabase: TEdit;
    editPersonalDatabase: TEdit;
    tableDummy: TTable;
    procedure bitbtnCancelClick(Sender: TObject);
    procedure bitbtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure SetAlias(AliasName, AliasPath: String);
  public
  end;

var
  formMain: TformMain;

implementation

{$R *.DFM}

//*************************************************************************
//*
//*************************************************************************
procedure TformMain.bitbtnCancelClick(Sender: TObject);
begin
  Close;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.SetAlias(AliasName, AliasPath: String);
var
  AliasNameList : TStringList;
  AliasParams   : TStringList;
  Index         : Integer;
  Matched       : boolean;
  NumOfAliases  : word;
begin
  AliasNameList:=TStringList.Create;
  Session.GetAliasNames(AliasNameList);
  NumOfAliases:=AliasNameList.Count;
  Matched:=AliasNameList.find(AliasName,Index);
  AliasNameList.Free;

  if Matched=False then begin
    //MessageDlg('Create.', mtInformation ,[mbOK],0);
    Session.AddStandardAlias(AliasName, AliasPath, 'PARADOX');
    Session.SaveConfigFile;
  end
  else begin
    //MessageDlg('Modify.', mtInformation ,[mbOK],0);
    AliasParams:=TStringList.Create;
    Session.GetAliasParams(AliasName, AliasParams);
    AliasParams.Values['PATH']:=AliasPath;
    Session.ModifyAlias(AliasName, AliasParams);
    Session.SaveConfigFile;
    AliasParams.Free;
  end;
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.bitbtnOKClick(Sender: TObject);
begin
  SetAlias('HYPERJUKE_C', editCommonDatabase.text);
  SetAlias('HYPERJUKE_P', editPersonalDatabase.text);
  MessageDlg('Finished.', mtInformation ,[mbOK],0);
end;


//*************************************************************************
//*
//*************************************************************************
procedure TformMain.FormCreate(Sender: TObject);
var
  CurrentDrvDir : string;
begin
  CurrentDrvDir:=ExtractFileDir(paramstr(0));
  editCommonDatabase.text:=CurrentDrvDir+'\common';
  editPersonalDatabase.text:=CurrentDrvDir+'\personal';
end;

end.
